#include once "crt.bi"

const as single pi = 3.1415926, pi2 = pi*2, pid2 = pi/2, pi_180 = pi/180, inv_pi_180 = 180/pi


type vec2f
    
	declare constructor ( byval x as single, byval y as single )
	declare constructor ( byref v as vec2f )
	
	declare constructor ( )
    
    x as single
    y as single
    
    declare operator cast() as string
    
    declare function dot ( byref v as vec2f ) as single
    declare function magnitude() as single
    declare sub normalize()
    declare function cross( byref v as vec2f ) as vec2f
    declare function cross_analog( byref v as vec2f ) as single
    declare function distance( byref v as vec2f ) as single
    declare function AngleBetween( byref v as vec2f ) as single
    
end type



type vec2i
	as integer x
	as integer y
end type




declare operator + ( byref lhs as vec2f, byref rhs as single ) as vec2f
declare operator + ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator - ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator * ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator * ( byref lhs as vec2f, byref rhs as single ) as vec2f
declare operator * ( byref lhs as vec2f, byref rhs as double ) as vec2f
declare operator / ( byref lhs as vec2f, byref rhs as integer  ) as vec2f
declare operator / ( byref lhs as vec2f, byref rhs as single  ) as vec2f

