#include once "fbgfx.bi"
#include once "fbpng.bi"
#include once "2dMathf.bi"

const as integer SCALE = 16


enum BlockType
	WALL
	GRASS
	SAND
	MUD
	WATER
end enum


enum ActionType

	WALK = 0

end enum


type PathStruct

	as vec2i p(any)

	declare sub add(np as vec2i)

end type


type TileStruct

	'as FB.IMAGE ptr frames(any)
	as integer animated
	as double fTime
	as BlockType bType
	id as integer
	
end type


type WorldStruct
	
	as FB.IMAGE ptr image(any)
	as vec2i	size
	as TileStruct tile(any,any)
	
end type


type EntityStruct
	
	as FB.IMAGE ptr image
	as FB.IMAGE ptr walk(7,15)
	
	
	as ActionType action
	as integer direction
	as single fcntr
	
	as vec2f p
	as vec2f dr(7)
	as PathStruct path

	declare constructor()
	declare destructor()

end type


declare sub drawmap( map as WorldStruct )
declare sub drawcharacter( dude as EntityStruct )

